#include "KdIntersectable.h"


namespace GtpVisibilityPreprocessor {


KdIntersectable::KdIntersectable(KdNode *node):
Intersectable(), mNode(node)
{
}


void KdIntersectable::SetNode(KdNode *node)
{
	mNode = node;
}


KdNode *KdIntersectable::GetNode() const
{ 
	return mNode; 
}
	

AxisAlignedBox3 KdIntersectable::GetBox() const
{	// TODO matt
	return AxisAlignedBox3();
}


int KdIntersectable::CastRay(Ray &ray)
{	// TODO matt
	return 0;
}
	

bool KdIntersectable::IsConvex() const
{
	return true;
}


bool KdIntersectable::IsWatertight() const
{
	return true;
}


float KdIntersectable::IntersectionComplexity()
{
	return 1.0f;
}


int KdIntersectable::NumberOfFaces() const
{
	return 0;
}


int KdIntersectable::Type() const
{
	return Intersectable::KD_INTERSECTABLE;
}


int KdIntersectable::GetRandomSurfacePoint(Vector3 &point,
										   Vector3 &normal)
{
	return 0;
}


int KdIntersectable::GetRandomVisibleSurfacePoint(Vector3 &point,
												  Vector3 &normal,
												  const Vector3 &viewpoint,
												  const int maxTries)
{
	return 0;
}
  

ostream &KdIntersectable::Describe(ostream &s)
{
	s << mNode;
	return s;
}
	
}